function championnat()

% Décommenter la ligne suivante pour connaitre le temps de calcul.
tic;

% Le nombre de simulations.
N = 70000;
% Nombre d'équipes impliquées dans le championnat.
nequipes = 16;
% Numéro de l'équipe de Nancy. Il suffit de modifier cette ligne pour
% traiter le cas où Nancy est l'équipe #16.
Nancy = 16;

% bilan est le nombre de simulations où l'équipe de Nancy a été classé
% championne.
bilan = 0;
% La boucle de Monte-Carlo.
for i = 0 : N-1
    % victoires(a) est le nombre de matches remportés par l'équipe #a.
    victoires = zeros(1,nequipes);
    for a = 1 : nequipes
        % On fait jouer chaque équipe contre l'autre une fois.
        for b = a+1 : nequipes
            % Probabilité de défaite de a.
            if rand < 1/(1+(b/a)^(1/2))
                victoires(b) = victoires(b) + 1;
            else
                victoires(a) = victoires(a) + 1;
            end
        end
    end
    % Une méthode pour départager uniformément les ex-æquo est d'ajouter
    % une partie fractionnaire aléatoire à chaque score.
    victoires = victoires + rand(1,nequipes);
    [~,championne] = max(victoires);
    if championne == Nancy
        bilan = bilan + 1;
    end
end
probabilite = bilan / N;
disp ('Probabilité de victoire évaluée pour l''équipe de Nancy :');
disp (probabilite);

% Décommenter les lignes suivantes pour avoir l'intervalle de confiance (à
% 5 p.c.). Noter que dans ce cas particulier de la méthode de rejet où on
% s'intéresse à une variable de Bernoulli, l'écart-type est s'exprime
% directement en fonction de la moyenne.
ecarttype = sqrt(probabilite*(1-probabilite));
disp ('±'); disp (1.96 * ecarttype/sqrt(N));

% Décommenter les lignes suivantes pour connaitre le temps de calcul.
t = toc;
disp ('Durée du calcul en s :');
disp (t);
end