function loterie

% Le nombre de simulations.
N = 700000;
% Nombre de numéros qu'il y a en jeu.
Nnumeros = 36;
% Nombre de boules tirées (et de paris à faire).
Ntirages = 12;
% total est le total des gains au cours des simulations.
total = 0;

% La boucle de Monte-Carlo.
for i = 0 : N-1
    
    % Comme tous les numéros sont interchangeables, tous les remplissages
    % de la grille sont équivalents ; on va donc supposer que notre joueuse
    % a fait un pari à 1 point sur le no 1, à 2 points sur le numéro 2,
    % ..., et à 12 points sur le numéro 12
    
    % On tire au sort les numéros qui sortent. "numerostires" est la liste
    % des numéros tirés, qu'on va remplir successivement.
    numerostires = zeros(1,Ntirages); 
    % "boules" est la liste des boules présentes dans l'urne.
    boules = 1 : Nnumeros;
    % On maintient aussi le nombre de boules restant dans l'urne, appelé
    % "nombredeboules", ainsi que le nombre de boules déjà tirées, appelé
    % "nombretirees".
    nombredeboules = Nnumeros;
    nombretirees = 0;
    
    % On tire successivement 12 boules.
    for j = 1 : Ntirages
        % "laboule" est la position de la boule tirée au sein de la liste des boules de l'urne.
        laboule = randi(nombredeboules);
        % On regarde le numéro correspondant et on l'ajoute à la liste des numéros tirés.
        numerostires(nombretirees+1) = boules(laboule);
        % On retire la boule de la liste des boules à tirer.
        boules (laboule) = boules (nombredeboules);
        nombredeboules = nombredeboules - 1;
        nombretirees = nombretirees + 1;
    end
        
    score = sum (numerostires .* (numerostires <= Ntirages));
    gain = floor(exp((score - 39)/8)) * (score >= 39);
    total = total + gain;
    
end

moyenne = total / N;
disp ('Gain moyen évalué :');
disp (moyenne);

end