function loterie_IC

% La fonction "loterie_IC" effectue le même travail que "loterie", mais en
% affichant en plus l'intervalle de confiance. Je ne commente que les
% différences.

N = 700000;
Nnumeros = 36;
Ntirages = 12;
total = 0;
% On maintient aussi le total des carrés cette fois-ci.
totalcarres = 0;

for i = 0 : N-1
    
    % La partie simulation de la boucle de Monte-Carlo reste inchangée.
    numerostires = zeros(1,Ntirages);
    boules = 1 : Nnumeros;
    nombredeboules = Nnumeros;
    nombretirees = 0;
    for j = 1 : Ntirages
        laboule = randi(nombredeboules);
        numerostires(nombretirees+1) = boules(laboule);
        boules (laboule) = boules (nombredeboules);
        nombredeboules = nombredeboules - 1;
        nombretirees = nombretirees + 1;
    end
    score = sum (numerostires .* (numerostires <= Ntirages));
    if score >= 39
        gain = floor(exp((score-39)/8));
    else
        gain = 0;
    end
    
    total = total + gain;
    % Il faut aussi maintenir le total des carrés.
    totalcarres = totalcarres + gain*gain;
end

moyenne = total / N;
% On estime l'écart-type de la quantité simulée par l'écart-type empirique.
ecarttype = sqrt(totalcarres / N - moyenne * moyenne);
disp ('Intervalle de confiance pour le gain moyen :');
% Un intervalle de confiance à 99,5 % correspond à 2,81 écarts-types.
disp ([num2str(moyenne),' ± ',num2str(2.81*ecarttype/sqrt(N))]);

end