% "mathfi_ctrl0" effectue le même travail que "mathfi_naif", mais en
% utilisant la variable de contrôle Y. Je ne commente que les différences
% avec "mathfi_naif".
function mathfi_ctrl0(N)
T = 60;
% Attention : cette fois-ci les variables "somme" et "somme2" ne se
% réfèreront pas à la simulation de "Xmax", mais à celle de Xmax-Y, où "Y"
% est la variable de contrôle.
somme = 0;
somme2 = 0;
for i = 1:N
    X = zeros(1,T+1);
    Xt = 0;
    for t = 1:T
        Xt = Xt + randn(1);
        X(t+1) = Xt;
    end
    Xmax = max(X);
    % On calcule la variable de contrôle.
    Y = max(X(T+1),0);
    % La quantité à laquelle on va appliquer la méthode de Monte-Carlo à
    % proprement parler est la différence Xmax-Y, notée "valeur".
    valeur = Xmax - Y;
    somme = somme + valeur;
    somme2 = somme2 + valeur*valeur;
end
% On évalue l'estimateur et la marge d'erreur pour E(valeur).
m = somme / N;
ectype = sqrt (somme2/N - m*m);
erreur = 1.96 * ectype / sqrt(N);
% On en déduit l'estimateur pour E(Xmax) = E(valeur) + E(Y), sachant qu'on
% sait calculer exactement E(Y), appelée ici "EY". Noter que l'addition de
% EY ne modifie pas la marge d'erreur.
EY = sqrt(T / (2*pi));
mXmax = m + EY;
erreurXmax = erreur;
fprintf('Estimation de E(X_*) : %.5f ± %.5f\n', mXmax, erreurXmax);
return
end